// AVAILABLE CHECK TYPES
//    PICOTEST_ASSERT(check1);
//    PICOTEST_VERIFY(0, "BETA");
//    PICOTEST_ABORT();
#include <time.h>
#include <errno.h>

#define W 20
#define H 12

void SetupSampleGrid() {
    smGrid(W,H);
    smgOn(1,1);
    smgOn(0,1);
    smgOn(10,1);
    smgOn(1,0);
    smgOn(1,8);
    smgOn(W-2,8);
    smgOn(W-2,H-2);
    smgOn(10,H-2);
    smgOn(10,H-2);
    smgOn(1,H-2);
    smgOn(W-2,1);
    smgOn(3,3);
    smgOn(3,4);
    smgOn(3,5);
    smgOn(4,3);
    smgOn(4,5);
    smgOn(5,3);
    smgOn(5,4);
    smgOn(5,5);
    smgOn(7,3);
    smgOn(9,3);
    smgOn(7,5);
    smgOn(9,5);
    smgOn(11,4);
    smgOn(13,4);
    smgOn(12,3);
    smgOn(12,5);
    smgOn(16,3);
    smgOn(16,4);
    smgOn(16,5);
    smgOn(17,3);
    smgOn(17,4);
    smgOn(17,5);
    smgOn(18,3);
    smgOn(18,4);
    smgOn(18,5);
}

PICOTEST_SUITE(mainSuite, OUT_OF_BOUNDS, ON_BOUNDS, IN_BOUNDS, LARGER_GRID)
PICOTEST_CASE(OUT_OF_BOUNDS) {
    smGrid(W,H);
    PICOTEST_VERIFY(countNeighbors(-1,-1)==-1, "Test at (-100,-100) failed.")
    PICOTEST_VERIFY(countNeighbors(-1,-1)==-1, "Test at (-1,-1) failed.")
    PICOTEST_VERIFY(countNeighbors(-1,5)==-1, "Test at (-1,5) failed.")
    PICOTEST_VERIFY(countNeighbors(5,-1)==-1, "Test at (5,-1) failed.")
    PICOTEST_VERIFY(countNeighbors(W,H)==-1, "Test at (W,H) failed.")
    PICOTEST_VERIFY(countNeighbors(W,10)==-1, "Test at (W,10) failed.")
    PICOTEST_VERIFY(countNeighbors(10,H)==-1, "Test at (10,H) failed.")
    PICOTEST_VERIFY(countNeighbors(-1,H)==-1, "Test at (-1,H) failed.")
    PICOTEST_VERIFY(countNeighbors(W,-1)==-1, "Test at (W,-1) failed.")
    PICOTEST_VERIFY(countNeighbors(100,100)==-1, "Test at (100,100) failed.")
}
PICOTEST_CASE(ON_BOUNDS) {
    SetupSampleGrid();
    smShowGrid(true);
    PICOTEST_VERIFY(countNeighbors(0,0)==3, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(10,0)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(W-1,0)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(0,H-1)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(10,H-1)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(W-1,H-1)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(10,H-1)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(W-1,H-1)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(W-1,H-1)==1, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(0,9)==2, "Test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(W-1,9)==2, "Test failed, see text grid to help you.")
}
PICOTEST_CASE(IN_BOUNDS) {
    SetupSampleGrid();
    PICOTEST_VERIFY(countNeighbors(4,4) == 8, "Round test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(8,4) == 4, "X test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(12,4) == 4, "Cross test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(17,4) == 8, "Over #1 test failed, see text grid to help you.")
    PICOTEST_VERIFY(countNeighbors(10,1) == 0, "Over #2 test failed, see text grid to help you.")
}
PICOTEST_CASE(LARGER_GRID) {
    smGrid(100,100);
    smgOn(95,95);
    smgOn(97,97);
    smGrid2Image();
    PICOTEST_VERIFY(countNeighbors(96,96) == 2, "Large grid test failed, see image to help you.")
}